package com.example.shelby.healthquest40;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.ServiceConnection;
import android.content.SharedPreferences;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.icu.text.SimpleDateFormat;
import java.util.Calendar;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.preference.PreferenceManager;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import java.util.Date;

import pl.droidsonroids.gif.GifImageView;


public class MainActivity extends Activity {

    private StepDetector stepDetector;
    private SensorManager sensorManager;
    private Sensor accel;
    public static Context contextOfApplication;

    //more pedometer.java
    private static final String TAG = "Pedometer";
    private SharedPreferences mSettings;
    private PedometerSettings mPedometerSettings;
    //private Utils mUtils;

    private int mStepValue;
    private float mDistanceValue;
    private boolean mQuitting = false; // Set when user selected Quit from menu, can be used by onPause, onStop, onDestroy


    /**
     * True, when service is running.
     */
    private boolean mIsRunning = true;
    //end from pedometer.java


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        contextOfApplication = getApplicationContext();

        SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        SharedPreferences.Editor myEditor = myPreferences.edit();

        SharedPreferences state = getSharedPreferences("state", 0);
        SharedPreferences.Editor stateEditor = state.edit();

        ///////////////////////////
        //code from pedometer .java
        ///////////////////////////
        Log.i(TAG, "[ACTIVITY] onCreate");
        super.onCreate(savedInstanceState);

        mStepValue = 0;

        //this can't touch main
        //setContentView(R.layout.main);

        //mUtils = Utils.getInstance();

        ///////////////
        //end code --> goes in oncreate
        ///////////////

        int [] characterArray = new int[]{R.drawable.lngblk_blu_olive,
                R.drawable.lngblk_grn_olive, R.drawable.lngblk_brn_olive, R.drawable.lngbrn_blu_olive,
                R.drawable.lngbrn_grn_olive, R.drawable.lngbrn_brn_olive, R.drawable.lngblnd_blu_olive,
                R.drawable.lngblnd_grn_olive, R.drawable.lngblnd_brn_olive, R.drawable.lngrd_blu_olive,
                R.drawable.lngrd_grn_olive, R.drawable.lngrd_brn_olive, R.drawable.shtblk_blu_olive,
                R.drawable.shtblk_grn_olive, R.drawable.shtblk_brn_olive, R.drawable.shtbrn_blu_olive,
                R.drawable.shtbrn_grn_olive, R.drawable.shtbrn_brn_olive, R.drawable.shtblnd_blu_olive,
                R.drawable.shtblnd_grn_olive, R.drawable.shtblnd_brn_olive, R.drawable.shtrd_blu_olive,
                R.drawable.shtgrd_grn_olive, R.drawable.shtgrd_brn_olive, R.drawable.bzblk_blu_olive,
                R.drawable.bzblk_grn_olive, R.drawable.bzblk_brn_olive, R.drawable.bzbrn_blu_olive,
                R.drawable.bzbrn_grn_olive, R.drawable.bzbrn_brn_olive, R.drawable.bzblnd_blu_olive,
                R.drawable.bzblnd_grn_olive, R.drawable.bzblnd_brn_olive, R.drawable.bzrd_blu_olive,
                R.drawable.bzrd_grn_olive, R.drawable.bzrd_brn_olive, R.drawable.lngblk_blu_brn,
                R.drawable.lngblk_grn_brn, R.drawable.lngblk_brn_brn, R.drawable.lngbrn_blu_brn,
                R.drawable.lngbrn_grn_brn, R.drawable.lngbrn_brn_brn, R.drawable.lngblnd_blu_brn,
                R.drawable.lngblnd_grn_brn, R.drawable.lngblnd_brn_brn, R.drawable.lngrd_blu_brn,
                R.drawable.lngrd_grn_brn, R.drawable.lngrd_brn_brn, R.drawable.shtblk_blu_brn,
                R.drawable.shtblk_grn_brn, R.drawable.shtblk_brn_brn, R.drawable.shtbrn_blu_brn,
                R.drawable.shtbrn_grn_brn, R.drawable.shtbrn_brn_brn, R.drawable.shtblnd_blu_brn,
                R.drawable.shtblnd_grn_brn, R.drawable.shtblnd_brn_brn, R.drawable.shtrd_blu_brn,
                R.drawable.shtrd_grn_brn, R.drawable.shtrd_brn_brn, R.drawable.bzblk_blu_brn,
                R.drawable.bzblk_grn_brn, R.drawable.bzblk_brn_brn, R.drawable.bzbrn_blu_brn,
                R.drawable.bzbrn_grn_brn, R.drawable.bzbrn_brn_brn, R.drawable.bzblnd_blu_brn,
                R.drawable.bzblnd_grn_brn, R.drawable.bzblnd_brn_brn, R.drawable.bzrd_blu_brn,
                R.drawable.bzrd_grn_brn, R.drawable.bzrd_brn_brn};

        sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
        accel = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
        stepDetector = new StepDetector();


        /************
         * USERNAME *
         ************/
        if (myPreferences.contains("USERNAME")) {
            TextView username = (TextView) findViewById(R.id.username_txt);
            username.setText(myPreferences.getString("USERNAME", "null"));
        } else {
            Intent intent = new Intent(this, Naming.class);
            startActivity(intent);
        }

        /*******************
         * CHARACTER MODEL *
         *******************/
        GifImageView character = (GifImageView) findViewById(R.id.maincharacter);
        if (myPreferences.contains("C_MODEL")) {
            character.setImageResource(characterArray[myPreferences.getInt("C_MODEL", 0)-1]);
        } else {
            character.setImageResource(characterArray[0]);
            myEditor.putInt("C_MODEL", 1);
        }

        /*******************
         * DAILY CHALLENGE *
         *******************/
        TextView dailychallenge = (TextView) findViewById(R.id.txt_daily_challenge);

        if (myPreferences.contains("MEDIUM")) {
            String challenge;
            if (myPreferences.getInt("MEDIUM", 0) == 0) {
                if (myPreferences.getFloat("DAILY_STEPS", 0) > myPreferences.getInt("QUANTITY", 0) ||
                        myPreferences.getBoolean("DAILY_CHALLENGE_MET", false) == false) {
                    challenge = "Congratulations! You overcame your daily challenge!";
                    myEditor.putBoolean("DAILY_CHALLENGE_MET", true);
                    if (myPreferences.getBoolean("EXP_RECEIVED", false) == false) {
                        myEditor.putInt("EXPERIENCE", (myPreferences.getInt("EXPERIENCE", 0) +
                                (myPreferences.getInt("EXPERIENCE", 0))/10));
                    } else {
                        //do nothing, experience has already been allocated
                    }

                    myEditor.commit();
                } else {
                    challenge = "Walk " + String.valueOf(myPreferences.getInt("QUANTITY", 0)) +
                            " steps today!";
                }
            } else if (myPreferences.getInt("MEDIUM", 0) == 1){
                if (myPreferences.getFloat("DAILY_DISTANCE", 0) > myPreferences.getInt("QUANTITY", 0) ||
                        myPreferences.getBoolean("DAILY_CHALLENGE_MET", false) == false) {
                    challenge = "Congratulations! You overcame your daily challenge!";
                    myEditor.putBoolean("DAILY_CHALLENGE_MET", true);
                    myEditor.putInt("EXPERIENCE", (myPreferences.getInt("EXPERIENCE", 0) +
                            (myPreferences.getInt("EXPERIENCE", 0))/10));
                    myEditor.commit();
                } else {
                    challenge = "Walk " + String.valueOf(myPreferences.getInt("QUANTITY", 0)) +
                            " miles today!";
                }
            } else {
                challenge = "Set a daily challenge in the settings menu!";
            }
            dailychallenge.setText(challenge);
        } else {
            String challenge;
            challenge = "Set a daily challenge in the settings menu!";
            dailychallenge.setText(challenge);
        }

        /******************
         * MAX EXPERIENCE *
         ******************/
        ProgressBar Progress2LevelUp = (ProgressBar) findViewById(R.id.level_prog_bar);

        if (myPreferences.contains("MAX_EXP")) {
            Progress2LevelUp.setMax(myPreferences.getInt("MAX_EXP", 100));
        } else {
            Progress2LevelUp.setMax(100);
            myEditor.putInt("MAX_EXP", 100);
        }

        /**************
         * EXPERIENCE *
         ***************/
        //uses the same progress bar as MAX_EXP
        if (myPreferences.contains("EXPERIENCE")) {
            Progress2LevelUp.setProgress(myPreferences.getInt("EXPERIENCE", 0));
        } else {
            Progress2LevelUp.setProgress(0);
            myEditor.putInt("EXPERIENCE", 0);
        }

        /*********
         * LEVEL *
         *********/
        TextView leveldisplay = (TextView) findViewById(R.id.num_level_txt);
        if (myPreferences.contains("LEVEL")) {
            leveldisplay.setText(String.valueOf(myPreferences.getInt("LEVEL", 0)));
        } else {
            leveldisplay.setText(String.valueOf(1));
            myEditor.putInt("LEVEL", 1);
        }

        /*********
         * COINS *
         *********/
        TextView coindisplay = (TextView) findViewById(R.id.num_coins_txt);
        if (myPreferences.contains("COINS")) {
            coindisplay.setText(String.valueOf(myPreferences.getInt("COINS", 1000)));
        } else {
            coindisplay.setText(String.valueOf(1000));
            myEditor.putInt("COINS", 1000);
        }

        /***************
         * DAILY STEPS *
         ***************/
        TextView dailysteps = (TextView) findViewById(R.id.num_dailysteps);
        if (myPreferences.contains("DAILY_STEPS")) {
            dailysteps.setText(String.valueOf((int)myPreferences.getFloat("DAILY_STEPS", 0)));
        } else {
            dailysteps.setText(String.valueOf(0));
            myEditor.putFloat("DAILY_STEPS", 0);
        }

        /*******************
         * AVG DAILY STEPS *
         *******************/
        TextView avgstepsdisplay = (TextView) findViewById(R.id.num_avgsteps);
        if (myPreferences.contains("AVG_DAILY_STEPS")) {
            avgstepsdisplay.setText(String.valueOf((int)myPreferences.getFloat("AVG_DAILY_STEPS", 0)));
        } else {
            avgstepsdisplay.setText(String.valueOf(0));
            myEditor.putFloat("AVG_DAILY_STEPS", 0);
        }

        /******************
         * DAILY DISTANCE *
         ******************/
        TextView dailydistance = (TextView) findViewById(R.id.num_dailydist);

        if (myPreferences.contains("DAILY_DISTANCE")) {
            float flo = myPreferences.getFloat("DAILY_DISTANCE", 0);
            double dub = flo-(flo%.01);
            dailydistance.setText(String.valueOf(dub));
        } else {
            dailydistance.setText(String.valueOf(0));
            myEditor.putFloat("DAILY_DISTANCE", 0);
        }

        /**********************
         * AVG DAILY DISTANCE *
         **********************/
        TextView avgdailydist = (TextView) findViewById(R.id.num_avgdist);
        if (myPreferences.contains("AVG_DAILY_DISTANCE")) {
            float flo = myPreferences.getFloat("AVG_DAILY_DISTANCE", 0);
            double dub = flo-(flo%.01);
            avgdailydist.setText(String.valueOf(dub));
        } else {
            avgdailydist.setText(String.valueOf(0));
            myEditor.putFloat("AVG_DAILY_DISTANCE", 0);
        }

        /**********
         * ENERGY *
         **********/
        TextView energydisplay = (TextView) findViewById(R.id.num_energy_txt);
        if (myPreferences.contains("ENERGY")) {
            if (myPreferences.contains("USED_ENERGY")) {
                myEditor.putInt("ENERGY", (((int)myPreferences.getFloat("DAILY_STEPS", 0)/100) +
                        (myPreferences.getInt("LEFTOVER_ENERGY", 0))));
                energydisplay.setText(String.valueOf((myPreferences.getInt("ENERGY", 0))-(myPreferences.getInt("USED_ENERGY", 0))));
            } else {
                myEditor.putInt("USED_ENERGY", 0);
                myEditor.putInt("ENERGY", (int)myPreferences.getFloat("DAILY_STEPS", 0)/100);
                energydisplay.setText(String.valueOf((myPreferences.getInt("ENERGY", 0))-(myPreferences.getInt("USED_ENERGY", 0))));
            }
            myEditor.commit();
        } else {
            energydisplay.setText(String.valueOf(5));
            myEditor.putInt("ENERGY", 5);
            myEditor.putInt("USED_ENERGY", 0);
            myEditor.commit();
        }

        /*****************
         * SETTING ITEMS *
         *****************/
        //health potion
        if (myPreferences.contains("HEALTHPOT_QUANTITY")) {
            //do nothing
        } else {
            myEditor.putInt("HEALTHPOT_QUANTITY", 0);
        }

        //attack potion
        if (myPreferences.contains("ATKPOT_QUANTITY")) {
            //do nothing
        } else {
            myEditor.putInt("ATKPOT_QUANTITY", 0);
        }

        //defense potion
        if (myPreferences.contains("DEFPOT_QUANTITY")) {
            //do nothing
        } else {
            myEditor.putInt("DEFPOT_QUANTITY", 0);
        }

        /******************************
         * SETTING BOOLEANS FOR QUEST *
         ******************************/
        myEditor.putBoolean("HEALTHPOT_ACTIVE", false);
        myEditor.putBoolean("ATKPOT_ACTIVE", false);
        myEditor.putBoolean("DEFPOT_ACTIVE", false);

        myEditor.commit();


    }

    public static Context getContextofApplication() {
        /******************************************************************************
         * Returns MainActivity's context. Used for SharedPreferences in .java files. *
         ******************************************************************************/
        return contextOfApplication;
    }

    public void Shop(View view) {
        /***************************************************************
         * Starts the Shop activity when the "SHOP" button is pressed. *
         ***************************************************************/
        Intent intent = new Intent(this, shop.class);
        startActivity(intent);
    }

    public void Quest(View view) {
        /*****************************************************************
         * Starts the Quest activity when the "QUEST" button is pressed. *
         * It subtracts one energy when it is pressed, so backing out    *
         * of the Quest mode will not refund the energy.                 *
         *****************************************************************/
        SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        SharedPreferences.Editor myEditor = myPreferences.edit();
        if (myPreferences.getInt("ENERGY", 0) < 1) {
            //if you press "QUEST" and don't have any energy to spend
            Toast.makeText(getBaseContext(), "You don't have enough energy!", Toast.LENGTH_SHORT).show();
        }
        else {
            //subtract one point of energy
            myEditor.putInt("ENERGY", myPreferences.getInt("ENERGY", 0)-1);
            myEditor.putInt("USED_ENERGY", (myPreferences.getInt("USED_ENERGY", 0)+1));
            myEditor.commit();
            //open the Quest activity
            Intent intent = new Intent(this, Quest.class);
            startActivity(intent);

        }
    }

    public void Settings(View view) {
        /**************************************************************
         * Starts the Settings activity when the "SETTINGS" button is *
         * pressed.                                                   *
         **************************************************************/
        Intent intent = new Intent(this, settings.class);
        startActivity(intent);
    }

    public void Customize(View view) {
        /*************************************************************
         * Starts the Customize activity when the "CUSTOMIZE" button *
         * is pressed.                                               *
         *************************************************************/
        Intent intent = new Intent(this, customize.class);
        startActivity(intent);
    }

    public void inventory(View view) {
        /*************************************************************
         * Starts the Inventory activity when the "INVENTORY" button *
         * is pressed.                                               *
         *************************************************************/
        Intent intent = new Intent(this, Inventory_2.class);
        startActivity(intent);
    }


    @Override
    protected void onStart() {
        /********************************************************
         * onStart is called automatically when the application *
         * is started.                                          *
         ********************************************************/
        Log.i(TAG, "[ACTIVITY] onStart");
        super.onStart();
    }

    @Override
    protected void onResume() {
        /**********************************************************
         * onResume is called automatically when the app is       *
         * restarted. It reactivates the listeners and reattaches *
         * the step service, so it can begin tracking statistics  *
         * again.                                                 *
         **********************************************************/
        Log.i(TAG, "[ACTIVITY] onResume");
        super.onResume();

        bindStepService();
    }

    @Override
    protected void onPause() {
        /********************************************************
         * onPause is called automatically when the user first  *
         * moves away from the activity. It releases the step   *
         * service, and stores the last time the app was active *
         * in mPedometerSettings.                               *
         ********************************************************/

        Log.i(TAG, "[ACTIVITY] onPause");
        if (mIsRunning) {
            unbindStepService();
        }

        super.onPause();
    }

    @Override
    protected void onStop() {
        /********************************************************
         * onStop is called when the app is officially in the   *
         * background.                                          *
         ********************************************************/
        Log.i(TAG, "[ACTIVITY] onStop");
        super.onStop();
    }

    protected void onDestroy() {
        /*****************************************************
         * onDestroy is called when the app is force closed. *
         *****************************************************/
        Log.i(TAG, "[ACTIVITY] onDestroy");
        super.onDestroy();
    }

    protected void onRestart() {
        /******************************************************
         * onRestart is called when the app is restarted from *
         * being force closed.                                *
         ******************************************************/
        Log.i(TAG, "[ACTIVITY] onRestart");
        super.onRestart();
    }

    private StepService mService;
    private ServiceConnection mConnection = new ServiceConnection() {
        /********************************************************
         * This function starts up and shuts off the connection *
         * to the step service.                                 *
         ********************************************************/
        public void onServiceConnected(ComponentName className, IBinder service) {
            mService = ((StepService.StepBinder)service).getService();
        }
        public void onServiceDisconnected(ComponentName className) {
            mService = null;
        }
    };

    private void bindStepService() {
        /**********************************************************************
         * bindStepService attaches the Service to the Main Activity.         *
         * This is why the steps are only counted while in the Main Activity. *
         **********************************************************************/
        Log.i(TAG, "[SERVICE] Bind");
        bindService(new Intent(MainActivity.this,
                StepService.class), mConnection, Context.BIND_AUTO_CREATE + Context.BIND_DEBUG_UNBIND);
    }

    private void unbindStepService() {
        /***********************************************************************
         * unbindStepService releases the step service while the Main Activity *
         * is not being used.                                                  *
         ***********************************************************************/
        Log.i(TAG, "[SERVICE] Unbind");
        unbindService(mConnection);
    }

    public void refresh(View view) {
        /***************************************************
         * refresh simply reloads the main page to give an *
         * updated view of steps, distance, and energy.    *
         ***************************************************/
        Intent intent = new Intent(this, MainActivity.class);
        startActivity(intent);
        finish();
    }

    public void restartdaily(View view) {
        /***************************************************************
         * restartdaily is called by the "daily restart" button on the *
         * main screen. it resets all the daily values and calculates  *
         * the new average, as well as recalculating how much energy   *
         * the user has.                                               *
         ***************************************************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Daily Reset");
        alert.setMessage("Would you like to perform the daily reset function?");
        alert.setPositiveButton("Yes!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /****************************************************
                 * This code is executed when the user clicks "Yes" *
                 ****************************************************/
                SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
                SharedPreferences.Editor myEditor = myPreferences.edit();

                /******************************************************
                 * ADJUST THE DAY COUNTER--USED TO CALCULATE AVERAGES *
                 ******************************************************/
                if (myPreferences.contains("DAY_COUNTER")) {
                    myEditor.putInt("DAY_COUNTER", (myPreferences.getInt("DAY_COUNTER", 0)+1));
                    myEditor.commit();
                } else {
                    myEditor.putInt("DAY_COUNTER", 1);
                    myEditor.commit();
                }

                /*****************************
                 * STORE THE LEFTOVER ENERGY *
                 *****************************/
                myEditor.putInt("LEFTOVER_ENERGY", ((myPreferences.getInt("ENERGY", 0))+(myPreferences.getInt("LEFTOVER_ENERGY", 0))-
                        (myPreferences.getInt("USED_ENERGY", 0))));
                myEditor.commit();

                /**********************************************
                 * CALCULATE AVERAGE STEPS & AVERAGE DISTANCE *
                 **********************************************/
                Float avgSteps, avgDist;
                avgSteps = (myPreferences.getFloat("AVG_DAILY_STEPS", 0) + myPreferences.getFloat("DAILY_STEPS", 0))/
                        (myPreferences.getInt("DAY_COUNTER_1", 1));
                avgDist = (myPreferences.getFloat("AVG_DAILY_DISTANCE", 0) + myPreferences.getFloat("DAILY_DISTANCE", 0))/
                        (myPreferences.getInt("DAY_COUNTER", 1));

                /****************
                 * RESET VALUES *
                 ****************/
                myEditor.putBoolean("DAILY_CHALLENGE_MET", false);
                myEditor.putBoolean("EXP_RECEIVED", false);
                myEditor.putFloat("AVG_DAILY_STEPS", avgSteps); //updates avg steps
                myEditor.putFloat("DAILY_STEPS", 0);
                myEditor.putFloat("AVG_DAILY_DISTANCE", avgDist); //updates avg dist
                myEditor.putFloat("DAILY_DISTANCE", 0);
                myEditor.remove("MEDIUM"); //clears steps vs distance in daily challenge
                myEditor.remove("QUANTITY"); //clears num in daily challenge
                myEditor.remove("USED_ENERGY");
                myEditor.commit();

                tomain();
            }
        });
        alert.setNegativeButton("NO!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });

        alert.show();


    }

    void tomain () {
        /****************************
         * RELAUNCHES MAIN ACTIVITY *
         ****************************/
        Intent intent = new Intent(this, MainActivity.class);
        startActivity(intent);
        finish();
    }
}