/*
 *  Pedometer - Android App
 *  Copyright (C) 2009 Levente Bagi
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * This version of SpeakingTimer.java was edited by Shelby Kirn
 * no later than Wednesday, May 3, 2017.
 */

package com.example.shelby.healthquest40;

import java.util.ArrayList;

/**
 * Call all listening objects repeatedly.
 * The interval is defined by the user settings.
 * @author Levente Bagi
 */
public class SpeakingTimer {
    /*********************************************
     * Adds Listeners to objects as it's called. *
     *********************************************/

    public interface Listener {
        public void speak();
    }
    private ArrayList<Listener> mListeners = new ArrayList<Listener>();

    public void addListener(Listener l) {
        /********************
         * Adds a listener. *
         ********************/
        mListeners.add(l);
    }
}