package com.example.shelby.healthquest40;

import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.ImageView;
import android.widget.Toast;

public class inQuestItem extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_inventory_2);

    }

    public void AtkPot(View view) {
        /**************************************************
         * AtkPot sets up the pop-up window that appears  *
         * when the button for Attack Potions is clicked. *
         **************************************************/
        /***********************************
         * INITIALIZING SHARED PREFERENCES *
         ***********************************/
        final SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        final SharedPreferences.Editor myEditor = myPreferences.edit();

        /************************************
         * INITIALIZING IMAGEVIEWS AND TEXT *
         ************************************/
        ImageView atkpot = new ImageView (this);
        atkpot.setImageResource(R.drawable.atkpot);
        String text = "A bright green potion. It is very cold." + "\n" +
                "Doubles the damage you do for one Quest." + "\n" +
                "Current Quantity: " + (String.valueOf(myPreferences.getInt("ATKPOT_QUANTITY", 0)));

        /****************************
         * SETTING UP POP-UP WINDOW *
         ****************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Attack Potion"); //sets the title of the pop-up
        alert.setMessage(text); //places flavor text and quantity on the pop-up
        alert.setPositiveButton("USE", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /*************************************************
                 * This function is called when the user selects *
                 * the affirmation button on the pop-up window.  *
                 *************************************************/
                if (!(myPreferences.getBoolean("ATKPOT_ACTIVE", false)) &&
                        myPreferences.getInt("ATKPOT_QUANTITY", 0) > 0) {
                    //if the user has not used an attack potion on this quest
                    //and they have at least one in their inventory
                    myEditor.putBoolean("ATKPOT_ACTIVE", true);
                    myEditor.putInt("ATKPOT_QUANTITY", (myPreferences.getInt("ATKPOT_QUANTITY", 0)-1));
                    myEditor.commit();
                } else if (myPreferences.getBoolean("ATKPOT_ACTIVE", false) == true) {
                    //if the user has used an attack potion on this quest
                    Toast.makeText(getBaseContext(), "You've already used one this quest!", Toast.LENGTH_SHORT).show();
                } else if (myPreferences.getInt("ATKPOT_QUANTITY", 0) <= 0) {
                    //if the user does not have an attack potion in their inventory
                    Toast.makeText(getBaseContext(), "You don't have any!", Toast.LENGTH_SHORT).show();
                }
            }
        });
        alert.setNegativeButton("DON'T USE", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });
        alert.setView(atkpot); //setting a picture of the attack potion on the pop-up
        alert.show(); //display the pop-up
    }

    public void DefPot(View view) {
        /***************************************************
         * DefPot sets up the pop-up window that appears   *
         * when the button for Defense Potions is clicked. *
         ***************************************************/
        /***********************************
         * INITIALIZING SHARED PREFERENCES *
         ***********************************/
        final SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        final SharedPreferences.Editor myEditor = myPreferences.edit();

        /************************************
         * INITIALIZING IMAGEVIEWS AND TEXT *
         ************************************/
        ImageView defpot = new ImageView (this);
        defpot.setImageResource(R.drawable.defensepot);
        String text = "A dark blue potion. It is heavier than it looks." + "\n" +
                "Halves the damage you take for one Quest." + "\n" +
                "Current Quantity: " + (String.valueOf(myPreferences.getInt("DEFPOT_QUANTITY", 0)));


        /****************************
         * SETTING UP POP-UP WINDOW *
         ****************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Defense Potion"); //sets the title of the pop-up
        alert.setMessage(text); //places flavor text and quantity on the pop-up
        alert.setPositiveButton("USE", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /*************************************************
                 * This function is called when the user selects *
                 * the affirmation button on the pop-up window.  *
                 *************************************************/
                if (!(myPreferences.getBoolean("DEFPOT_ACTIVE", false)) &&
                        myPreferences.getInt("DEFPOT_QUANTITY", 0) > 0) {
                    //if the user has not used a defense potion on this quest
                    //and they have at least one in their inventory
                    myEditor.putBoolean("DEFPOT_ACTIVE", true);
                    myEditor.putInt("DEFPOT_QUANTITY", (myPreferences.getInt("DEFPOT_QUANTITY", 0)-1));
                    myEditor.commit();
                } else if (myPreferences.getBoolean("DEFPOT_ACTIVE", false) == true) {
                    //if the user has used a defense potion on this quest
                    Toast.makeText(getBaseContext(), "You've already used one this quest!", Toast.LENGTH_SHORT).show();
                } else if (myPreferences.getInt("DEFPOT_QUANTITY", 0) <= 0) {
                    //if the user does not have a defense potion in their inventory
                    Toast.makeText(getBaseContext(), "You don't have any!", Toast.LENGTH_SHORT).show();
                }
            }
        });
        alert.setNegativeButton("DON'T USE", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });
        alert.setView(defpot); //setting a picture of the defense potion on the pop-up
        alert.show(); //display the pop-up
    }

    public void HealthPot(View view) {
        /****************************************************
         * HealthPot sets up the pop-up window that appears *
         * when the button for Health Potions is clicked.   *
         ****************************************************/
        /***********************************
         * INITIALIZING SHARED PREFERENCES *
         ***********************************/
        final SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
        final SharedPreferences.Editor myEditor = myPreferences.edit();

        /************************************
         * INITIALIZING IMAGEVIEWS AND TEXT *
         ************************************/
        ImageView healthpot = new ImageView (this);
        healthpot.setImageResource(R.drawable.healthpot);
        String text = "A comforting red potion. It is warm to the touch."+ "\n" +
                "Restores half your HP." + "\n" +
                "Current Quantity: " + (String.valueOf(myPreferences.getInt("HEALTHPOT_QUANTITY", 0)));

        /****************************
         * SETTING UP POP-UP WINDOW *
         ****************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Health Potion");
        alert.setMessage(text);
        alert.setPositiveButton("USE", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /*************************************************
                 * This function is called when the user selects *
                 * the affirmation button on the pop-up window.  *
                 *************************************************/
                if (myPreferences.getInt("HEALTHPOT_QUANTITY", 0) <= 0) {
                    //if the user does not have a health potion in their inventory
                    Toast.makeText(getBaseContext(), "You don't have any!", Toast.LENGTH_SHORT).show();
                } else {
                    //subtract one health potion
                    myEditor.putInt("HEALTHPOT_QUANTITY", (myPreferences.getInt("HEALTHPOT_QUANTITY", 0) - 1));
                    if ((myPreferences.getInt("HERO_CURRENT_HEALTH", 0) +
                            (myPreferences.getInt("MAX_HERO_HEALTH", 0) / 2)) > 100) {
                        //if the user has more than half their health, set their health to max
                        myEditor.putInt("HERO_CURRENT_HEALTH", (myPreferences.getInt("MAX_HERO_HEALTH", 0) / 2));
                        myEditor.commit();
                    } else {
                        //if the user has less than half their current health, add half their total health
                        myEditor.putInt("CURRENT_HERO_HEALTH", (myPreferences.getInt("CURRENT_HERO_HEALTH", 0) +
                                (myPreferences.getInt("MAX_HERO_HEALTH", 0) / 2)));
                        myEditor.commit();
                    }
                }
            }
        });
        alert.setNegativeButton("DON'T USE", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });
        alert.setView(healthpot); //setting a picture of the health potion on the pop-up
        alert.show(); //display the pop-up
    }
}
