package com.example.shelby.healthquest40;

import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;


public class settings extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_settings);
    }

    public void renaming(View view) {
        /**********************************************************************************
         * renaming allows you to rename your hero. it opens an alert dialog that prompts *
         * the user to enter their new name via the keyboard.                             *
         **********************************************************************************/
        final AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Pick your new name!"); //setting the title of the pop-up
        alert.setMessage("Enter your new name."); //setting the message of the pop-up
        final EditText newname = new EditText(settings.this); //establish an EditText
        LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams(
                LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.MATCH_PARENT);
        newname.setLayoutParams(lp); //adjust the parameters of the EditText
        alert.setView(newname); //set the EditText on the pop-up
        alert.setPositiveButton("That's my name!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /*************************************************
                 * This function is called when the user selects *
                 * the affirmation button on the pop-up window.  *
                 *************************************************/
                SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
                SharedPreferences.Editor myEditor = myPreferences.edit();
                myEditor.putString("USERNAME", String.valueOf(newname.getText()));
                myEditor.commit();
                back2main();
            }
        });
        alert.setNegativeButton("Nevermind!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });
        alert.show();
    }

    public void back2main() {
        /*******************************************************
         * a function that sends you back to the main activity *
         *******************************************************/
        Intent intent = new Intent (this, MainActivity.class);
        startActivity(intent);
        finish();
    }

    public void clear_dsa(View view) {
        /***********************************************************************************
         * clears your daily step average. will ask for confirmation in case of accidental *
         * button pressing. it opens a dialog window, and clears the average after the     *
         * user confirms.                                                                  *
         ***********************************************************************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("You're deleting stuff!");
        alert.setMessage("You are about to clear your average daily step records. Are you sure?");
        alert.setNegativeButton("No!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing if the negative response button is clicked
            }
        });
        alert.setPositiveButton("Yes!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /*************************************************
                 * This function is called when the user selects *
                 * the affirmation button on the pop-up window.  *
                 *************************************************/
                SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
                SharedPreferences.Editor myEditor = myPreferences.edit();
                myEditor.putFloat("AVG_DAILY_STEPS", 0); //reset average steps to zero
                myEditor.putInt("DAY_COUNTER_1", 0); //reset the number of days the average has been calculated
                myEditor.commit();
            }
        });

        alert.show();
    }

    public void clear_dda(View view) {
        /******************************************************************
         * clears your daily distance average. will ask for confirmation. *
         ******************************************************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("You're deleting stuff!");
        alert.setMessage("You are about to clear your average daily distance records. Are you sure?");
        alert.setNegativeButton("No!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {

            }
        });
        alert.setPositiveButton("Yes!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /*************************************************
                 * This function is called when the user selects *
                 * the affirmation button on the pop-up window.  *
                 *************************************************/
                SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
                SharedPreferences.Editor myEditor = myPreferences.edit();
                myEditor.putFloat("AVG_DAILY_DISTANCE", 0); //reset average distance to zero
                myEditor.putFloat("DAY_COUNTER", 0); //resets the number of days the average has been calculated
                myEditor.commit();
            }
        });

        alert.show();
    }

    public void daily_challenge_set(View view) {
        Intent intent = new Intent(this, DailyChallenge.class);
        startActivity(intent);
    }

    public void clear_account(View view) {
        /****************************************************************************************
         * a function that clears everything. this will reset your name, statistics, as well as *
         * your progress through the game. will ask for confirmation.                           *
         ****************************************************************************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("You're deleting a lot of stuff!");
        alert.setMessage("You are about to clear ALL your records. You will not be able to recover them. Are you sure?");
        alert.setNegativeButton("No!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing :)
            }
        });
        alert.setPositiveButton("Yes!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /*************************************************
                 * This function is called when the user selects *
                 * the affirmation button on the pop-up window.  *
                 *************************************************/
                /***********************************
                 * INITIALIZING SHARED PREFERENCES *
                 ***********************************/
                SharedPreferences myPreferences = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
                SharedPreferences.Editor myEditor = myPreferences.edit();

                /*****************
                 * REMOVING DATA *
                 *****************/
                myEditor.remove("USERNAME");
                myEditor.remove("LEVEL");
                myEditor.remove("EXPERIENCE");
                myEditor.remove("MAX_EXP");
                myEditor.remove("COINS");
                myEditor.remove("ENERGY");
                myEditor.remove("C_MODEL");
                myEditor.remove("DAILY_STEPS");
                myEditor.remove("AVG_DAILY_STEPS");
                myEditor.remove("DAILY_DISTANCE");
                myEditor.remove("AVG_DAILY_DISTANCE");
                myEditor.remove("USED_ENERGY");
                myEditor.remove("MEDIUM");
                myEditor.remove("QUANTITY");
                myEditor.remove("DAILY_CHALLENGE_MET");
                myEditor.remove("DAY_COUNTER");
                myEditor.remove("DAY_COUNTER_1");
                myEditor.remove("LEFTOVER_ENERGY");

                /********************
                 * RESET ALL VALUES *
                 ********************/
                myEditor.putInt("LEVEL", 1);
                myEditor.putInt("EXPERIENCE", 0);
                myEditor.putInt("MAX_EXP", 100);
                myEditor.putInt("COINS", 1000);
                myEditor.putInt("ENERGY", 5);
                myEditor.putInt("C_MODEL", 1);
                myEditor.putFloat("DAILY_STEPS", 0);
                myEditor.putFloat("AVG_DAILY_STEPS", 0);
                myEditor.putFloat("DAILY_DISTANCE", 0);
                myEditor.putFloat("AVG_DAILY_DISTANCE", 0);
                myEditor.putInt("ATKPOT_QUANTITY", 0);
                myEditor.putInt("HEALTHPOT_QUANTITY", 0);
                myEditor.putInt("DEFPOT_QUANTITY", 0);
                myEditor.commit();

                restart();
            }
        });

        alert.show();
    }

    public void restart() {
        /************************************************************
         * This function puts the user back on the naming page, and *
         * they will be prompted to walk though the initial setup   *
         * of the app again.                                        *
         ************************************************************/
        Intent intent = new Intent(this, Naming.class);
        startActivity(intent);
    }

    public void swordPoke(View view) {
        /***********************************************************
         * This function is called when the user touches the sword *
         * image on the settings page. I was bored.                *
         ***********************************************************/
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Ouch!");
        alert.setMessage("Don't touch that, it's sharp!");
        alert.setPositiveButton(":(", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing
            }
        });

        alert.show();
    }

    public void Licenses(View view) {
        AlertDialog.Builder alert = new AlertDialog.Builder(this);
        alert.setTitle("Licensing");
        alert.setMessage("As HealthQuest uses code from Leventi Bagi's Pedometer app, " +
                "which is licensed under the GNU General Public License, HealthQuest " +
                "also falls under this license. Would you like to read through it?");
        alert.setNegativeButton("Nevermind", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //do nothing if the negative response button is clicked
            }
        });
        alert.setPositiveButton("Yes!", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                /*************************************************
                 * This function is called when the user selects *
                 * the affirmation button on the pop-up window.  *
                 *************************************************/
                Intent intent = new Intent();
                intent.setAction(Intent.ACTION_VIEW);
                intent.addCategory(Intent.CATEGORY_BROWSABLE);
                intent.setData(Uri.parse("http://www.gnu.org/licenses/gpl.html"));
                startActivity(intent);
            }
        });

        alert.show();
    }
}
